//Keybind code ripped from Ephialtes' quicksave, and commandtoserver('unusetool'); was suggested by Ephialtes
//Stolen from Ephialtes who stole from Randy
function AddBind(%division, %name, %command)
{
	for(%i=0;%i<$remapCount;%i++)
	{
		if($remapDivision[%i] $= %division)
		{
			%foundDiv = 1;
			continue;
		}
		if(%foundDiv && $remapDivision[%i] !$= "")
		{
			%position = %i;
			break;
		}
	}
	if(!%foundDiv)
	{
		error("Division not found: " @ %division);
		return;
	}
	if(!%position)
	{
		$remapName[$remapCount] = %name;
		$remapCmd[$remapCount] = %command;
		$remapCount++;
		return;
	}
	for(%i=$remapCount;%i>%position;%i--)
	{
		$remapDivision[%i] = $remapDivision[%i - 1];
		$remapName[%i] = $remapName[%i - 1];
		$remapCmd[%i] = $remapCmd[%i - 1];
	}
	$remapDivision[%position] = "";
	$remapName[%position] = %name;
	$remapCmd[%position] = %command;
	$remapCount++;
}

if(!$ConsoleRebindInit)
{
	AddBind("Gui", "Open/Close Console", "toggleConsole");
	$ConsoleRebindInit = true;
}

package ConsoleRebind
{
	function OptRemapInputCtrl::onInputEvent(%this, %device, %action)
	{
		if($RemapName[%this.index] $= "Open/Close Console")
		{
			if(%device $= "keyboard")
			{
				if(%action $= "escape" || %action $= "backspace")
				{
					Parent::onInputEvent(%this, %device, %action);
					return;
				}
			}
		}

		%old = moveMap.getCommand(%device, %action);
		if(GlobalActionMap.getBinding(%old))
			GlobalActionMap.unbind(%device, %action);

		Parent::onInputEvent(%this, %device, %action);
		if(%device $= "keyboard")
		{
			if(%action $= "escape" || %action $= "backspace")
				return;
		}

		if($RemapName[%this.index] $= "Open/Close Console" && %old $= "")
		{
			GlobalActionMap.unbind("keyboard", "tilde");
			GlobalActionMap.bind(%device, %action, "toggleConsole");
		}
	}

	function redoMapping(%device, %action, %cmd, %oldIndex, %newIndex)
	{
		Parent::redoMapping(%device, %action, %cmd, %oldIndex, %newIndex);
		if(%cmd $= "toggleConsole")
			GlobalActionMap.bind(%device, %action, "toggleConsole");
	}

	function OptRemapList::fillList(%this)
	{
		if((%MoveMapStr = GlobalActionMap.getBinding("toggleConsole")) !$= "")
		{
			%MoveMapDevice = getField(%MoveMapStr, 0);
			%MoveMapAction = getField(%MoveMapStr, 1);

			%weDidItJohnny = 1;
			moveMap.bind(%MoveMapDevice, %MoveMapAction, "toggleConsole");
		}

		Parent::fillList(%this);

		//this might be useless to do
		if(%weDidItJohnny == 1)
			moveMap.unbind(%MoveMapDevice, %MoveMapAction);
	}

	function optionsDlg::onSleep(%this)
	{
		if((%MoveMapStr = GlobalActionMap.getBinding("toggleConsole")) !$= "")
		{
			%MoveMapDevice = getField(%MoveMapStr, 0);
			%MoveMapAction = getField(%MoveMapStr, 1);

			%weDidItJohnny = 1;
			moveMap.bind(%MoveMapDevice, %MoveMapAction, "toggleConsole");
		}

		Parent::onSleep(%this);

		//this might be useless to do
		if(%weDidItJohnny == 1)
			moveMap.unbind(%MoveMapDevice, %MoveMapAction);
	}

	function defaultControlsGui::onSleep()
	{
		if((%MoveMapStr = GlobalActionMap.getBinding("toggleConsole")) !$= "")
		{
			%MoveMapDevice = getField(%MoveMapStr, 0);
			%MoveMapAction = getField(%MoveMapStr, 1);

			%weDidItJohnny = 1;
			moveMap.bind(%MoveMapDevice, %MoveMapAction, "toggleConsole");
		}

		Parent::onSleep();

		//this might be useless to do
		if(%weDidItJohnny == 1)
			moveMap.unbind(%MoveMapDevice, %MoveMapAction);
	}

	function onExit()
	{
		if((%MoveMapStr = GlobalActionMap.getBinding("toggleConsole")) !$= "")
		{
			%MoveMapDevice = getField(%MoveMapStr, 0);
			%MoveMapAction = getField(%MoveMapStr, 1);

			moveMap.bind(%MoveMapDevice, %MoveMapAction, "toggleConsole");
		}

		return Parent::onExit();
	}
};
activatePackage("ConsoleRebind");

function RebindConsole()
{
	if((%MoveMapStr = moveMap.getBinding("toggleConsole")) !$= "")
	{
		%MoveMapDevice = getField(%MoveMapStr, 0);
		%MoveMapAction = getField(%MoveMapStr, 1);

		if(%MoveMapDevice $= "keyboard" && %MoveMapAction !$= "tilde" && %MoveMapAction !$= "grave")
		{
			GlobalActionMap.unbind("keyboard", "tilde");

			GlobalActionMap.bind(%MoveMapDevice, %MoveMapAction, "toggleConsole");
			moveMap.unbind(%MoveMapDevice, %MoveMapAction);
		}
	}
}
schedule(0, 0, "RebindConsole");